﻿using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Actions;

namespace Common.Win.Common {
    public static class ActionExtenions {
        public static void CloneParameter(this ActionBase clone, ActionBase ori) {
            if(ori.GetType() != clone.GetType())
                return;
            SingleChoiceAction scaclone = clone as SingleChoiceAction;
            if(scaclone != null) {
                var scaori = ori as SingleChoiceAction;
                if(scaori != null)
                    scaclone.SelectedItem = scaori.SelectedItem;
                return;
            }
            ParametrizedAction parclone = clone as ParametrizedAction;
            if(parclone != null) {
                var parori = ori as ParametrizedAction;
                if(parori != null)
                    parclone.Value = parori.Value;
            }
        }

        public static void DoExecute(this ActionBase actionBase) {
            SimpleAction simpleAction = actionBase as SimpleAction;
            if(simpleAction != null) {
                simpleAction.DoExecute();
                return;
            }
            SingleChoiceAction singleChoiceAction = actionBase as SingleChoiceAction;
            if(singleChoiceAction != null) {
                singleChoiceAction.DoExecute(singleChoiceAction.SelectedItem);
                return;
            }

            PopupWindowShowAction popupWindowShowAction = actionBase as PopupWindowShowAction;
            if(popupWindowShowAction != null) {
                popupWindowShowAction.DoExecute((Window)popupWindowShowAction.Controller.Frame);
                return;
            }

            ParametrizedAction parametrizedAction = actionBase as ParametrizedAction;
            if(parametrizedAction != null)
                parametrizedAction.DoExecute(parametrizedAction.Value);
        }
    }
}
