﻿using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Security;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sample.Security
{
    public class ThreadSafeSecurityStrategyComplex : SecurityStrategyComplex
    {
        public ThreadSafeSecurityStrategyComplex(Type userType, Type roleType, AuthenticationBase authentication) : base(userType, roleType, authentication) { }

        protected override void ReloadPermissionsCore()
        {
            if (User == null)
                return;

            if (LogonObjectSpace == null)
            {
                base.ReloadPermissionsCore();
                return;
            }

            lock (LogonObjectSpace)
            {
                base.ReloadPermissionsCore();
            }
        }

        public override bool IsGranted(IPermissionRequest permissionRequest)
        {
            if (LogonObjectSpace == null)
            {
                return base.IsGranted(permissionRequest);
            }
            lock (LogonObjectSpace)
            {
                return base.IsGranted(permissionRequest);
            }
        }

        public override IList<bool> IsGranted(IList<IPermissionRequest> permissionRequests)
        {
            if (LogonObjectSpace == null)
            {
                return base.IsGranted(permissionRequests);
            }
            lock (LogonObjectSpace)
            {
                return base.IsGranted(permissionRequests);
            }
        }
    }
}
