﻿using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Security;
using System;
using System.Linq;

namespace Sample.Security
{
    public class ThreadSafeSelectDataSecurityProvider : ISelectDataSecurityProvider
    {
        private readonly SecurityStrategyComplex _securityStrategyComplex;

        public ThreadSafeSelectDataSecurityProvider(SecurityStrategyComplex securityStrategyComplex)
        {
            _securityStrategyComplex = securityStrategyComplex;
        }

        public ISelectDataSecurity CreateSelectDataSecurity()
        {
            if (_securityStrategyComplex.LogonObjectSpace == null)
                return ((ISelectDataSecurityProvider)_securityStrategyComplex).CreateSelectDataSecurity();
            lock (_securityStrategyComplex.LogonObjectSpace)
            {
                return ((ISelectDataSecurityProvider)_securityStrategyComplex).CreateSelectDataSecurity();
            }
        }

        public ISelectDataSecurity CreateSelectDataSecurity(IObjectSpace objectSpace)
        {
            if (_securityStrategyComplex.LogonObjectSpace == null)
                return ((ISelectDataSecurityProvider)_securityStrategyComplex).CreateSelectDataSecurity(objectSpace);
            lock (_securityStrategyComplex.LogonObjectSpace)
            {
                return ((ISelectDataSecurityProvider)_securityStrategyComplex).CreateSelectDataSecurity(objectSpace);
            }
        }
    }
}
